/** 
 * If caseExpression argument is null it indicate default label.
 */
void addSwitchCase(Node switchBlock,Node caseExpression,Node statements){
  if (switchBlock.getType() != Token.BLOCK)   throw Kit.codeBug();
  Node.Jump switchNode=(Node.Jump)switchBlock.getFirstChild();
  if (switchNode.getType() != Token.SWITCH)   throw Kit.codeBug();
  Node gotoTarget=Node.newTarget();
  if (caseExpression != null) {
    Node.Jump caseNode=new Node.Jump(Token.CASE,caseExpression);
    caseNode.target=gotoTarget;
    switchNode.addChildToBack(caseNode);
  }
 else {
    switchNode.setDefault(gotoTarget);
  }
  switchBlock.addChildToBack(gotoTarget);
  switchBlock.addChildToBack(statements);
}
