/** 
 * Return <tt>possibleDynamicScope</tt> if <tt>staticTopScope</tt> is present on its prototype chain and return <tt>staticTopScope</tt> otherwise. Should only be called when <tt>staticTopScope</tt> is top scope.
 */
static Scriptable checkDynamicScope(Scriptable possibleDynamicScope,Scriptable staticTopScope){
  if (possibleDynamicScope == staticTopScope) {
    return possibleDynamicScope;
  }
  Scriptable proto=possibleDynamicScope;
  for (; ; ) {
    proto=proto.getPrototype();
    if (proto == staticTopScope) {
      return possibleDynamicScope;
    }
    if (proto == null) {
      return staticTopScope;
    }
  }
}
