/** 
 * Construct a ClassFileWriter for a class.
 * @param className the name of the class to write, includingfull package qualification.
 * @param superClassName the name of the superclass of the classto write, including full package qualification.
 * @param sourceFileName the name of the source file to use forproducing debug information, or null if debug information is not desired
 */
public ClassFileWriter(String className,String superClassName,String sourceFileName){
  generatedClassName=className;
  itsConstantPool=new ConstantPool(this);
  itsThisClassIndex=itsConstantPool.addClass(className);
  itsSuperClassIndex=itsConstantPool.addClass(superClassName);
  if (sourceFileName != null)   itsSourceFileNameIndex=itsConstantPool.addUtf8(sourceFileName);
  itsFlags=ACC_PUBLIC;
}
