/** 
 * Add a field to the class.
 * @param fieldName the name of the field
 * @param type the type of the field using ...
 * @param flags the attributes of the field, such as ACC_PUBLIC, etc.bitwise or'd together
 * @param value an initial double value
 */
public void addField(String fieldName,String type,short flags,double value){
  short fieldNameIndex=itsConstantPool.addUtf8(fieldName);
  short typeIndex=itsConstantPool.addUtf8(type);
  ClassFileField field=new ClassFileField(fieldNameIndex,typeIndex,flags);
  field.setAttributes(itsConstantPool.addUtf8("ConstantValue"),(short)0,(short)2,itsConstantPool.addConstant(value));
  itsFields.add(field);
}
