/** 
 * Add Information about java variable to use when generating the local variable table.
 * @param name variable name.
 * @param type variable type as bytecode descriptor string.
 * @param startPC the starting bytecode PC where this variable is live,or -1 if it does not have a Java register.
 * @param register the Java register number of variableor -1 if it does not have a Java register.
 */
public void addVariableDescriptor(String name,String type,int startPC,int register){
  int nameIndex=itsConstantPool.addUtf8(name);
  int descriptorIndex=itsConstantPool.addUtf8(type);
  int[] chunk={nameIndex,descriptorIndex,startPC,register};
  if (itsVarDescriptors == null) {
    itsVarDescriptors=new ObjArray();
  }
  itsVarDescriptors.add(chunk);
}
