private Object compileImpl(Scriptable scope,Reader sourceReader,String sourceString,String sourceName,int lineno,Object securityDomain,boolean returnFunction,Evaluator compiler,ErrorReporter compilationErrorReporter) throws IOException {
  if (securityDomain != null && getSecurityController() == null) {
    throw new IllegalArgumentException("securityDomain should be null if setSecurityController() was never called");
  }
  if (!(sourceReader == null ^ sourceString == null))   Kit.codeBug();
  if (!(scope == null ^ returnFunction))   Kit.codeBug();
  CompilerEnvirons compilerEnv=new CompilerEnvirons();
  compilerEnv.initFromContext(this);
  if (compilationErrorReporter == null) {
    compilationErrorReporter=compilerEnv.getErrorReporter();
  }
  if (debugger != null) {
    if (sourceReader != null) {
      sourceString=Kit.readReader(sourceReader);
      sourceReader=null;
    }
  }
  Parser p=new Parser(compilerEnv,compilationErrorReporter);
  if (returnFunction) {
    p.calledByCompileFunction=true;
  }
  ScriptOrFnNode tree;
  if (sourceString != null) {
    tree=p.parse(sourceString,sourceName,lineno);
  }
 else {
    tree=p.parse(sourceReader,sourceName,lineno);
  }
  if (returnFunction) {
    if (!(tree.getFunctionCount() == 1 && tree.getFirstChild() != null && tree.getFirstChild().getType() == Token.FUNCTION)) {
      throw new IllegalArgumentException("compileFunction only accepts source with single JS function: " + sourceString);
    }
  }
  if (compiler == null) {
    compiler=createCompiler();
  }
  String encodedSource=p.getEncodedSource();
  Object bytecode=compiler.compile(compilerEnv,tree,encodedSource,returnFunction);
  if (debugger != null) {
    if (sourceString == null)     Kit.codeBug();
    if (bytecode instanceof DebuggableScript) {
      DebuggableScript dscript=(DebuggableScript)bytecode;
      notifyDebugger_r(this,dscript,sourceString);
    }
 else {
      throw new RuntimeException("NOT SUPPORTED");
    }
  }
  Object result;
  if (returnFunction) {
    result=compiler.createFunctionObject(this,scope,bytecode,securityDomain);
  }
 else {
    result=compiler.createScriptObject(bytecode,securityDomain);
  }
  return result;
}
