/** 
 * Object Literals <BR> createObjectLiteral rewrites its argument as object creation plus object property entries, so later compiler stages don't need to know about object literals.
 */
Node createObjectLiteral(ObjArray elems){
  int size=elems.size() / 2;
  Node object=new Node(Token.OBJECTLIT);
  Object[] properties;
  if (size == 0) {
    properties=ScriptRuntime.emptyArgs;
  }
 else {
    properties=new Object[size];
    for (int i=0; i != size; ++i) {
      properties[i]=elems.get(2 * i);
      Node value=(Node)elems.get(2 * i + 1);
      object.addChildToBack(value);
    }
  }
  object.putProp(Node.OBJECT_IDS_PROP,properties);
  return object;
}
