/** 
 * The delete operator See ECMA 11.4.1 In ECMA 0.19, the description of the delete operator (11.4.1) assumes that the [[Delete]] method returns a value. However, the definition of the [[Delete]] operator (8.6.2.5) does not define a return value. Here we assume that the [[Delete]] method doesn't return a value.
 */
public static Object delete(Object obj,Object id,Context cx){
  Scriptable sobj=toObjectOrNull(cx,obj);
  if (sobj == null) {
    String idStr=(id == null) ? "null" : id.toString();
    throw typeError2("msg.undef.prop.delete",toString(obj),idStr);
  }
  boolean result=deleteObjectElem(sobj,id,cx);
  return wrapBoolean(result);
}
