private Node destructuringAssignmentHelper(int variableType,Node left,Node right,String tempName){
  Node result=createScopeNode(Token.LETEXPR,parser.getCurrentLineNumber());
  result.addChildToFront(new Node(Token.LET,createName(Token.NAME,tempName,right)));
  try {
    parser.pushScope(result);
    parser.defineSymbol(Token.LET,tempName);
  }
  finally {
    parser.popScope();
  }
  Node comma=new Node(Token.COMMA);
  result.addChildToBack(comma);
  final int setOp=variableType == Token.CONST ? Token.SETCONST : Token.SETNAME;
  List<String> destructuringNames=new ArrayList<String>();
  boolean empty=true;
  int type=left.getType();
  if (type == Token.ARRAYLIT) {
    int index=0;
    int[] skipIndices=(int[])left.getProp(Node.SKIP_INDEXES_PROP);
    int skip=0;
    Node n=left.getFirstChild();
    for (; ; ) {
      if (skipIndices != null) {
        while (skip < skipIndices.length && skipIndices[skip] == index) {
          skip++;
          index++;
        }
      }
      if (n == null)       break;
      Node rightElem=new Node(Token.GETELEM,createName(tempName),createNumber(index));
      if (n.getType() == Token.NAME) {
        String name=n.getString();
        comma.addChildToBack(new Node(setOp,createName(Token.BINDNAME,name,null),rightElem));
        if (variableType != -1) {
          parser.defineSymbol(variableType,name);
          destructuringNames.add(name);
        }
      }
 else {
        comma.addChildToBack(destructuringAssignmentHelper(variableType,n,rightElem,parser.currentScriptOrFn.getNextTempName()));
      }
      index++;
      empty=false;
      n=n.getNext();
    }
  }
 else   if (type == Token.OBJECTLIT) {
    int index=0;
    Object[] propertyIds=(Object[])left.getProp(Node.OBJECT_IDS_PROP);
    for (Node n=left.getFirstChild(); n != null; n=n.getNext()) {
      Object id=propertyIds[index];
      Node rightElem=id instanceof String ? new Node(Token.GETPROP,createName(tempName),createString((String)id)) : new Node(Token.GETELEM,createName(tempName),createNumber(((Number)id).intValue()));
      if (n.getType() == Token.NAME) {
        String name=n.getString();
        comma.addChildToBack(new Node(setOp,createName(Token.BINDNAME,name,null),rightElem));
        if (variableType != -1) {
          parser.defineSymbol(variableType,name);
          destructuringNames.add(name);
        }
      }
 else {
        comma.addChildToBack(destructuringAssignmentHelper(variableType,n,rightElem,parser.currentScriptOrFn.getNextTempName()));
      }
      index++;
      empty=false;
    }
  }
 else   if (type == Token.GETPROP || type == Token.GETELEM) {
    comma.addChildToBack(simpleAssignment(left,createName(tempName)));
  }
 else {
    parser.reportError("msg.bad.assign.left");
  }
  if (empty) {
    comma.addChildToBack(createNumber(0));
  }
  result.putProp(Node.DESTRUCTURING_NAMES,destructuringNames);
  return result;
}
