/** 
 * Return statement in the loop body must be consistent. The default assumption for any kind of a loop is that it will eventually terminate. The only exception is a loop with a constant true condition. Code that follows such a loop is examined only if one can statically determine that there is a break out of the loop. for(<> ; <>; <>) {} for(<> in <> ) {} while(<>) { } do { } while(<>)
 * @return logical OR of END_* flags
 */
private int endCheckLoop(){
  Node n;
  int rv=END_UNREACHED;
  for (n=first; n.next != last; n=n.next) {
  }
  if (n.type != Token.IFEQ)   return END_DROPS_OFF;
  rv=((Jump)n).target.next.endCheck();
  if (n.first.type == Token.TRUE)   rv&=~END_DROPS_OFF;
  rv|=getIntProp(CONTROL_BLOCK_PROP,END_UNREACHED);
  return rv;
}
