/** 
 * Consistency of return statements is checked between the case statements. If there is no default, then the switch can fall through. If there is a default,we check to see if all code paths in the default return or if there is a code path that can fall through.
 * @return logical OR of END_* flags
 */
private int endCheckSwitch(){
  Node n;
  int rv=END_UNREACHED;
  for (n=first.next; n != null; n=n.next) {
    if (n.type == Token.CASE) {
      rv|=((Jump)n).target.endCheck();
    }
 else     break;
  }
  rv&=~END_DROPS_OFF;
  n=((Jump)this).getDefault();
  if (n != null)   rv|=n.endCheck();
 else   rv|=END_DROPS_OFF;
  rv|=getIntProp(CONTROL_BLOCK_PROP,END_UNREACHED);
  return rv;
}
