/** 
 * If the block has a finally, return consistency is checked in the finally block. If all code paths in the finally returns, then the returns in the try-catch blocks don't matter. If there is a code path that does not return or if there is no finally block, the returns of the try and catch blocks are checked for mismatch.
 * @return logical OR of END_* flags
 */
private int endCheckTry(){
  Node n;
  int rv=END_UNREACHED;
  n=((Jump)this).getFinally();
  if (n != null) {
    rv=n.next.first.endCheck();
  }
 else {
    rv=END_DROPS_OFF;
  }
  if ((rv & END_DROPS_OFF) != 0) {
    rv&=~END_DROPS_OFF;
    rv|=first.endCheck();
    n=((Jump)this).target;
    if (n != null) {
      for (n=n.next.first; n != null; n=n.next.next) {
        rv|=n.next.first.next.first.endCheck();
      }
    }
  }
  return rv;
}
