/** 
 * Get a Context associated with the current thread, using the given  Context if need be. <p> The same as <code>enterContext()</code> except that <code>cx</code> is associated with the current thread and returned if the current thread has no associated context and <code>cx</code> is not associated with any other thread.
 * @param cx a Context to associate with the thread if possible
 * @return a Context associated with the current thread
 * @see #enterContext()
 * @see #call(ContextAction)
 * @throws IllegalStateException if <code>cx</code> is already associatedwith a different thread
 */
public final Context enterContext(Context cx){
  return Context.enter(cx,this);
}
