/** 
 * Evaluate a reader as JavaScript source. All characters of the reader are consumed.
 * @param scope the scope to execute in
 * @param in the Reader to get JavaScript source from
 * @param sourceName a string describing the source, such as a filename
 * @param lineno the starting line number
 * @param securityDomain an arbitrary object that specifies securityinformation about the origin or owner of the script. For implementations that don't care about security, this value may be null.
 * @return the result of evaluating the source
 * @exception IOException if an IOException was generated by the Reader
 */
public final Object evaluateReader(Scriptable scope,Reader in,String sourceName,int lineno,Object securityDomain) throws IOException {
  Script script=compileReader(scope,in,sourceName,lineno,securityDomain);
  if (script != null) {
    return script.exec(this,scope);
  }
 else {
    return null;
  }
}
