/** 
 * Evaluate a JavaScript source string. The provided source name and line number are used for error messages and for producing debug information.
 * @param scope the scope to execute in
 * @param source the JavaScript source
 * @param sourceName a string describing the source, such as a filename
 * @param lineno the starting line number
 * @param securityDomain an arbitrary object that specifies securityinformation about the origin or owner of the script. For implementations that don't care about security, this value may be null.
 * @return the result of evaluating the string
 * @see org.mozilla.javascript.SecurityController
 */
public final Object evaluateString(Scriptable scope,String source,String sourceName,int lineno,Object securityDomain){
  Script script=compileString(source,sourceName,lineno,securityDomain);
  if (script != null) {
    return script.exec(this,scope);
  }
 else {
    return null;
  }
}
