/** 
 * Notify any registered listeners that a bounded property has changed
 * @see #addPropertyChangeListener(java.beans.PropertyChangeListener)
 * @see #removePropertyChangeListener(java.beans.PropertyChangeListener)
 * @see java.beans.PropertyChangeListener
 * @see java.beans.PropertyChangeEvent
 * @param property  the bound property
 * @param oldValue  the old value
 * @param newValue   the new value
 */
final void firePropertyChange(String property,Object oldValue,Object newValue){
  Object listeners=propertyListeners;
  if (listeners != null) {
    firePropertyChangeImpl(listeners,property,oldValue,newValue);
  }
}
