private Node function(int functionType) throws IOException, ParserException {
  int syntheticType=functionType;
  int baseLineno=ts.getLineno();
  int functionSourceStart=decompiler.markFunctionStart(functionType);
  String name;
  Node memberExprNode=null;
  if (matchToken(Token.NAME)) {
    name=ts.getString();
    decompiler.addName(name);
    if (!matchToken(Token.LP)) {
      if (compilerEnv.isAllowMemberExprAsFunctionName()) {
        Node memberExprHead=nf.createName(name);
        name="";
        memberExprNode=memberExprTail(false,memberExprHead);
      }
      mustMatchToken(Token.LP,"msg.no.paren.parms");
    }
  }
 else   if (matchToken(Token.LP)) {
    name="";
  }
 else {
    name="";
    if (compilerEnv.isAllowMemberExprAsFunctionName()) {
      memberExprNode=memberExpr(false);
    }
    mustMatchToken(Token.LP,"msg.no.paren.parms");
  }
  if (memberExprNode != null) {
    syntheticType=FunctionNode.FUNCTION_EXPRESSION;
  }
  if (syntheticType != FunctionNode.FUNCTION_EXPRESSION && name.length() > 0) {
    defineSymbol(Token.FUNCTION,name);
  }
  boolean nested=insideFunction();
  FunctionNode fnNode=nf.createFunction(name);
  if (nested || nestingOfWith > 0) {
    fnNode.itsIgnoreDynamicScope=true;
  }
  int functionIndex=currentScriptOrFn.addFunction(fnNode);
  int functionSourceEnd;
  ScriptOrFnNode savedScriptOrFn=currentScriptOrFn;
  currentScriptOrFn=fnNode;
  Node.Scope savedCurrentScope=currentScope;
  currentScope=fnNode;
  int savedNestingOfWith=nestingOfWith;
  nestingOfWith=0;
  Hashtable savedLabelSet=labelSet;
  labelSet=null;
  ObjArray savedLoopSet=loopSet;
  loopSet=null;
  ObjArray savedLoopAndSwitchSet=loopAndSwitchSet;
  loopAndSwitchSet=null;
  boolean savedHasReturnValue=hasReturnValue;
  int savedFunctionEndFlags=endFlags;
  Node destructuring=null;
  Node body;
  try {
    decompiler.addToken(Token.LP);
    if (!matchToken(Token.RP)) {
      boolean first=true;
      do {
        if (!first)         decompiler.addToken(Token.COMMA);
        first=false;
        int tt=peekToken();
        if (tt == Token.LB || tt == Token.LC) {
          if (destructuring == null) {
            destructuring=new Node(Token.COMMA);
          }
          String parmName=currentScriptOrFn.getNextTempName();
          defineSymbol(Token.LP,parmName);
          destructuring.addChildToBack(nf.createDestructuringAssignment(Token.VAR,primaryExpr(),nf.createName(parmName)));
        }
 else {
          mustMatchToken(Token.NAME,"msg.no.parm");
          String s=ts.getString();
          defineSymbol(Token.LP,s);
          decompiler.addName(s);
        }
      }
 while (matchToken(Token.COMMA));
      mustMatchToken(Token.RP,"msg.no.paren.after.parms");
    }
    decompiler.addToken(Token.RP);
    mustMatchToken(Token.LC,"msg.no.brace.body");
    decompiler.addEOL(Token.LC);
    body=parseFunctionBody();
    if (destructuring != null) {
      body.addChildToFront(new Node(Token.EXPR_VOID,destructuring,ts.getLineno()));
    }
    mustMatchToken(Token.RC,"msg.no.brace.after.body");
    if (compilerEnv.isStrictMode() && !body.hasConsistentReturnUsage()) {
      String msg=name.length() > 0 ? "msg.no.return.value" : "msg.anon.no.return.value";
      addStrictWarning(msg,name);
    }
    if (syntheticType == FunctionNode.FUNCTION_EXPRESSION && name.length() > 0 && currentScope.getSymbol(name) == null) {
      defineSymbol(Token.FUNCTION,name);
    }
    decompiler.addToken(Token.RC);
    functionSourceEnd=decompiler.markFunctionEnd(functionSourceStart);
    if (functionType != FunctionNode.FUNCTION_EXPRESSION) {
      decompiler.addToken(Token.EOL);
    }
  }
  finally {
    hasReturnValue=savedHasReturnValue;
    endFlags=savedFunctionEndFlags;
    loopAndSwitchSet=savedLoopAndSwitchSet;
    loopSet=savedLoopSet;
    labelSet=savedLabelSet;
    nestingOfWith=savedNestingOfWith;
    currentScriptOrFn=savedScriptOrFn;
    currentScope=savedCurrentScope;
  }
  fnNode.setEncodedSourceBounds(functionSourceStart,functionSourceEnd);
  fnNode.setSourceName(sourceURI);
  fnNode.setBaseLineno(baseLineno);
  fnNode.setEndLineno(ts.getLineno());
  Node pn=nf.initFunction(fnNode,functionIndex,body,syntheticType);
  if (memberExprNode != null) {
    pn=nf.createAssignment(Token.ASSIGN,memberExprNode,pn);
    if (functionType != FunctionNode.FUNCTION_EXPRESSION) {
      pn=nf.createExprStatementNoReturn(pn,baseLineno);
    }
  }
  return pn;
}
