public static Object[] getArrayElements(Scriptable object){
  Context cx=Context.getContext();
  long longLen=NativeArray.getLengthProperty(cx,object);
  if (longLen > Integer.MAX_VALUE) {
    throw new IllegalArgumentException();
  }
  int len=(int)longLen;
  if (len == 0) {
    return ScriptRuntime.emptyArgs;
  }
 else {
    Object[] result=new Object[len];
    for (int i=0; i < len; i++) {
      Object elem=ScriptableObject.getProperty(object,i);
      result[i]=(elem == Scriptable.NOT_FOUND) ? Undefined.instance : elem;
    }
    return result;
  }
}
