/** 
 * Get the current Context. The current Context is per-thread; this method looks up the Context associated with the current thread. <p>
 * @return the Context associated with the current thread, ornull if no context is associated with the current thread.
 * @see ContextFactory#enterContext()
 * @see ContextFactory#call(ContextAction)
 */
public static Context getCurrentContext(){
  Object helper=VMBridge.instance.getThreadContextHelper();
  return VMBridge.instance.getContext(helper);
}
