/** 
 * Prepare for calling name(...): return function corresponding to name and make current top scope available as ScriptRuntime.lastStoredScriptable() for consumption as thisObj. The caller must call ScriptRuntime.lastStoredScriptable() immediately after calling this method.
 */
public static Callable getNameFunctionAndThis(String name,Context cx,Scriptable scope){
  Scriptable parent=scope.getParentScope();
  if (parent == null) {
    Object result=topScopeName(cx,scope,name);
    if (!(result instanceof Callable)) {
      if (result == Scriptable.NOT_FOUND) {
        throw notFoundError(scope,name);
      }
 else {
        throw notFunctionError(result,name);
      }
    }
    Scriptable thisObj=scope;
    storeScriptable(cx,thisObj);
    return (Callable)result;
  }
  return (Callable)nameOrFunction(cx,scope,parent,name,true);
}
