/** 
 * Retrieves a system property within a privileged block. Use it only when the property is used from within Rhino code and is not passed out of it.
 * @param name the name of the system property
 * @return the value of the system property
 */
public static String getSystemProperty(final String name){
  return (String)AccessController.doPrivileged(new PrivilegedAction(){
    public Object run(){
      return System.getProperty(name);
    }
  }
);
}
