/** 
 * Get a value corresponding to a key. <p> Since the Context is associated with a thread it can be used to maintain values that can be later retrieved using the current thread. <p> Note that the values are maintained with the Context, so if the Context is disassociated from the thread the values cannot be retrieved. Also, if private data is to be maintained in this manner the key should be a java.lang.Object whose reference is not divulged to untrusted code.
 * @param key the key used to lookup the value
 * @return a value previously stored using putThreadLocal.
 */
public final Object getThreadLocal(Object key){
  if (hashtable == null)   return null;
  return hashtable.get(key);
}
