/** 
 * Prepare for calling <expression>(...): return function corresponding to <expression> and make parent scope of the function available as ScriptRuntime.lastStoredScriptable() for consumption as thisObj. The caller must call ScriptRuntime.lastStoredScriptable() immediately after calling this method.
 */
public static Callable getValueFunctionAndThis(Object value,Context cx){
  if (!(value instanceof Callable)) {
    throw notFunctionError(value);
  }
  Callable f=(Callable)value;
  Scriptable thisObj=null;
  if (f instanceof Scriptable) {
    thisObj=((Scriptable)f).getParentScope();
  }
  if (thisObj == null) {
    if (cx.topCallScope == null)     throw new IllegalStateException();
    thisObj=cx.topCallScope;
  }
  if (thisObj.getParentScope() != null) {
    if (thisObj instanceof NativeWith) {
    }
 else     if (thisObj instanceof NativeCall) {
      thisObj=ScriptableObject.getTopLevelScope(thisObj);
    }
  }
  storeScriptable(cx,thisObj);
  return f;
}
