/** 
 * Initialize global controller that will be used for all security-related operations. The global controller takes precedence over already installed  {@link Context}-specific controllers and cause any subsequent call to {@link Context#setSecurityController(SecurityController)}to throw an exception. <p> The method can only be called once.
 * @see #hasGlobal()
 */
public static void initGlobal(SecurityController controller){
  if (controller == null)   throw new IllegalArgumentException();
  if (global != null) {
    throw new SecurityException("Cannot overwrite already installed global SecurityController");
  }
  global=controller;
}
