public static Scriptable newArrayLiteral(Object[] objects,int[] skipIndices,Context cx,Scriptable scope){
  final int SKIP_DENSITY=2;
  int count=objects.length;
  int skipCount=0;
  if (skipIndices != null) {
    skipCount=skipIndices.length;
  }
  int length=count + skipCount;
  if (length > 1 && skipCount * SKIP_DENSITY < length) {
    Object[] sparse;
    if (skipCount == 0) {
      sparse=objects;
    }
 else {
      sparse=new Object[length];
      int skip=0;
      for (int i=0, j=0; i != length; ++i) {
        if (skip != skipCount && skipIndices[skip] == i) {
          sparse[i]=Scriptable.NOT_FOUND;
          ++skip;
          continue;
        }
        sparse[i]=objects[j];
        ++j;
      }
    }
    return cx.newObject(scope,"Array",sparse);
  }
  Scriptable arrayObj=cx.newObject(scope,"Array",ScriptRuntime.emptyArgs);
  int skip=0;
  for (int i=0, j=0; i != length; ++i) {
    if (skip != skipCount && skipIndices[skip] == i) {
      ++skip;
      continue;
    }
    ScriptableObject.putProperty(arrayObj,i,objects[j]);
    ++j;
  }
  return arrayObj;
}
