public static byte[] readStream(InputStream is,int initialBufferCapacity) throws IOException {
  if (initialBufferCapacity <= 0) {
    throw new IllegalArgumentException("Bad initialBufferCapacity: " + initialBufferCapacity);
  }
  byte[] buffer=new byte[initialBufferCapacity];
  int cursor=0;
  for (; ; ) {
    int n=is.read(buffer,cursor,buffer.length - cursor);
    if (n < 0) {
      break;
    }
    cursor+=n;
    if (cursor == buffer.length) {
      byte[] tmp=new byte[buffer.length * 2];
      System.arraycopy(buffer,0,tmp,0,cursor);
      buffer=tmp;
    }
  }
  if (cursor != buffer.length) {
    byte[] tmp=new byte[cursor];
    System.arraycopy(buffer,0,tmp,0,cursor);
    buffer=tmp;
  }
  return buffer;
}
