private Node returnOrYield(int tt,boolean exprContext) throws IOException, ParserException {
  if (!insideFunction()) {
    reportError(tt == Token.RETURN ? "msg.bad.return" : "msg.bad.yield");
  }
  consumeToken();
  decompiler.addToken(tt);
  int lineno=ts.getLineno();
  Node e;
switch (peekTokenOrEOL()) {
case Token.SEMI:
case Token.RC:
case Token.EOF:
case Token.EOL:
case Token.ERROR:
case Token.RB:
case Token.RP:
case Token.YIELD:
    e=null;
  break;
default :
e=expr(false);
break;
}
int before=endFlags;
Node ret;
if (tt == Token.RETURN) {
if (e == null) {
endFlags|=Node.END_RETURNS;
}
 else {
endFlags|=Node.END_RETURNS_VALUE;
hasReturnValue=true;
}
ret=nf.createReturn(e,lineno);
if (nowAllSet(before,endFlags,Node.END_RETURNS | Node.END_RETURNS_VALUE)) {
addStrictWarning("msg.return.inconsistent","");
}
}
 else {
endFlags|=Node.END_YIELDS;
ret=nf.createYield(e,lineno);
if (!exprContext) ret=new Node(Token.EXPR_VOID,ret,lineno);
}
if (nowAllSet(before,endFlags,Node.END_YIELDS | Node.END_RETURNS_VALUE)) {
String name=((FunctionNode)currentScriptOrFn).getFunctionName();
if (name.length() == 0) addError("msg.anon.generator.returns","");
 else addError("msg.generator.returns",name);
}
return ret;
}
