/** 
 * Change the current error reporter.
 * @return the previous error reporter
 * @see org.mozilla.javascript.ErrorReporter
 */
public final ErrorReporter setErrorReporter(ErrorReporter reporter){
  if (sealed)   onSealedMutation();
  if (reporter == null)   throw new IllegalArgumentException();
  ErrorReporter old=getErrorReporter();
  if (reporter == old) {
    return old;
  }
  Object listeners=propertyListeners;
  if (listeners != null) {
    firePropertyChangeImpl(listeners,errorReporterProperty,old,reporter);
  }
  this.errorReporter=reporter;
  return old;
}
