/** 
 * Turn on or off generation of code with callbacks to track the count of executed instructions. Currently only affects JVM byte code generation: this slows down the generated code, but code generated without the callbacks will not be counted toward instruction thresholds. Rhino's interpretive mode does instruction counting without inserting callbacks, so there is no requirement to compile code differently.
 * @param generateObserverCount if true, generated code will containcalls to accumulate an estimate of the instructions executed.
 */
public void setGenerateObserverCount(boolean generateObserverCount){
  this.generateObserverCount=generateObserverCount;
}
