/** 
 * Set the current optimization level. <p> The optimization level is expected to be an integer between -1 and 9. Any negative values will be interpreted as -1, and any values greater than 9 will be interpreted as 9. An optimization level of -1 indicates that interpretive mode will always be used. Levels 0 through 9 indicate that class files may be generated. Higher optimization levels trade off compile time performance for runtime performance. The optimizer level can't be set greater than -1 if the optimizer package doesn't exist at run time.
 * @param optimizationLevel an integer indicating the level ofoptimization to perform
 * @since 1.3
 */
public final void setOptimizationLevel(int optimizationLevel){
  if (sealed)   onSealedMutation();
  if (optimizationLevel == -2) {
    optimizationLevel=-1;
  }
  checkOptimizationLevel(optimizationLevel);
  if (codegenClass == null)   optimizationLevel=-1;
  this.optimizationLevel=optimizationLevel;
}
