package mining.commits;

import java.util.List;

public class Commit {
	private String HASH;
	
	private String authorName;
	private String authorDate;
	
	private String committerName;
	private String committerDate;
	
	private String subject; //message
	private String body; // svn-id
		
	private List<CFile> cFiles;
	
	private int nTestFiles;
	private int nImplFiles;
	private int totalFiles;
	
	private int nAddFiles;
	private int nModifiedFiles;
	private int nNonAddandModifiedFiles;
	
	
	public String getHASH() {
		return HASH;
	}
	public void setHASH(String hash) {
		HASH = hash;
	}
	public String getAuthorName() {
		return authorName;
	}
	public void setAuthorName(String author) {
		this.authorName = author;
	}
	public String getSubject() {
		return subject;
	}
	public void setSubject(String subject) {
		this.subject = subject;
	}	
	public String getBody() {
		return body;
	}
	public void setBody(String body) {
		this.body = body;
	}	
	public void print(){
		if (this != null) {
			System.out.println("HASH: " + HASH);
			System.out.println("Author Name: " + authorName);
			System.out.println("Author Date: " + authorDate);
			System.out.println("Committer Name: " + committerName);
			System.out.println("Committer Date: " + committerDate);
			System.out.println("Subject: " + subject);			
			System.out.println("Body: " + body);
			System.out.println();
			System.out.println("Committed files: ");
			if (cFiles != null) {
				for (CFile f : cFiles){
					f.print();
				}
			}
			
		}
		System.out.println();
		System.out.println();
		
	}
	
	public String toString(){
		String s = "";
		s += "HASH: " + HASH + "\n";
		s += "Author Name: " + authorName + "\n";
		s += "Author Date" + authorDate + "\n";
		s += "Committer Name: " + committerName + "\n";
		s += "Committer Data: " + committerDate + "\n";
		s += "Subject: " + subject + "\n";
		s += "Body: " + body + "\n";
		s += "\n";
		s += "Committed files: " + "\n";
		if (cFiles != null) {
			for (CFile cfile : cFiles) {
				s += cfile.getStatus() + "     " + cfile.getName() + "\n";
			}
		}
		
		
		return s;
	}
	
	public String getCommitterName() {
		return committerName;
	}
	public void setCommitterName(String committerName) {
		this.committerName = committerName;
	}
	public String getCommitterDate() {
		return committerDate;
	}
	public void setCommitterDate(String committerDate) {
		this.committerDate = committerDate;
	}
	public String getAuthorDate() {
		return authorDate;
	}
	public void setAuthorDate(String authorDate) {
		this.authorDate = authorDate;
	}
	public List<CFile> getcFiles() {
		return cFiles;
	}
	
	public void setcFiles(List<CFile> cFiles) {
		this.cFiles = cFiles;
		if (cFiles != null) {
			totalFiles = cFiles.size();
			nTestFiles = calTestFiles();
			nImplFiles = totalFiles - nTestFiles;
		} else {
			totalFiles = nTestFiles = nImplFiles = 0;
		}
		
		//calculate number of Add and Modify files
		
		nAddFiles = nModifiedFiles = 0;
		
		if (cFiles == null) {
			return;
		}
		
		for (CFile cf : cFiles) {
			if (cf.getStatus().trim().equalsIgnoreCase("A")) {
				nAddFiles ++;
			} else if (cf.getStatus().trim().equalsIgnoreCase("M")) {
				nModifiedFiles ++;
			}
		}
		
		//number of non add and modified files
		nNonAddandModifiedFiles = totalFiles - nAddFiles - nModifiedFiles;
		
	}
	
	private int calTestFiles() {
		if (cFiles == null)
			return 0;
		else {
			int total = 0;
			for (CFile f :cFiles) {
				if (f.isTestFile()) {
					total ++;
				}
			}
			return total;
		}
	}
	public int getnTestFiles() {
		return nTestFiles;
	}
	public void setnTestFiles(int nTestFiles) {
		this.nTestFiles = nTestFiles;
	}
	public int getnImplFiles() {
		return nImplFiles;
	}
	public void setnImplFiles(int nImplFiles) {
		this.nImplFiles = nImplFiles;
	}
	public int getTotalFiles (){
		return this.totalFiles;
	}
	
	public boolean isPureTestCommit(){
		return nTestFiles == totalFiles;
	}
	
	public boolean isPureCUTCommit() {
		return nImplFiles == totalFiles;
	}
	
	public int getNoAddFiles() {
		return this.nAddFiles;
	}
	
	public int getNoModifiedFiles() {
		return this.nModifiedFiles;
	}
	
	public int getNoNonAddandModifiedFiles () {
		return this.nNonAddandModifiedFiles;
	}
	
}
