package rtp.extractor;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.nio.MappedByteBuffer;
import java.nio.channels.FileChannel;
import java.nio.charset.Charset;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.jdt.core.dom.AST;
import org.eclipse.jdt.core.dom.ASTNode;
import org.eclipse.jdt.core.dom.ASTParser;
import org.eclipse.jdt.core.dom.CompilationUnit;
import org.eclipse.jdt.core.dom.MethodDeclaration;
import org.eclipse.jdt.core.dom.TypeDeclaration;
import org.eclipse.jface.text.BadLocationException;
import org.eclipse.jface.text.Document;


import rtp.utility.FileSystem;

public class MethodExtractorStructured3 {
	private static Document fDocument;
	
	public static void main(String args[]) throws CoreException, IOException{
		
		System.out.println("Invoking comment extractor mehod: MethodExtractorStructured3");
		
		FileSystem fs = new FileSystem();
		String version = "4.0";
		//String codeDirectory = "/Users/ripon/RTS/subjects-ripon/commons-lang"+version+"/src/test/java"+version+"";
		//String codeDirectory = "/Users/ripon/RTS/subjects-ripon/jaxen"+version+"/src/java/test1.9";
		//String codeDirectory = "/Users/ripon/RTS/subjects-ripon/joda-time"+version+"/src/test"+version;
		//String codeDirectory = "/Users/ripon/RTS/subjects-ripon/timeandmoney"+version+"/tests/src"+version;
		//String codeDirectory = "/Users/ripon/RTS/subjects-ripon/mime4j"+version+"/src/test/java"+version;
		//String codeDirectory = "/Users/ripon/RTS/subjects-ripon/xstream"+version+"/src/test"+version;
		//String codeDirectory = "/Users/ripon/RTS/subjects-ripon/xmlsec"+version+"/src_unitTests1";
		//String outputDir = "/Users/ripon/RTS/result/timeandmoney"+version+"/method-doc-structured";
//		String codeDirectory = "/Users/assist/ndataset/dlo/projects/ant/ANT-18732/ant_fixed_954939";
//		String outputDir = "/Users/assist/ndataset/dlo/projects/method-java-structured/ant";

		String codeDirectory = args[0];
		String outputDir = args[1];
		String filterFile = args[2];
		
		int offset = codeDirectory.length();
		List<String> files = fs.getAllJavaFiles(codeDirectory, codeDirectory.length());
		Iterator <String> it = files.iterator();
		
		// added by Tung
		String[] filteredMethod = FileSystem.readFile(filterFile).split("\n");
		ArrayList<String> coveredMethods = new ArrayList<String>();

		for (int i=0; i< filteredMethod.length; i++) {
			coveredMethods.add(filteredMethod[i].trim());
		}
		// ended injecting code by Tung
		
		
		
		int count = 1;
		int fileCount = 0;
		System.out.println("Processing");
		while(it.hasNext()){
			
			fileCount++;

		String filePath = it.next();
		
		//System.out.println(fileCount+"\t"+filePath);

		String classFQN = filePath.substring(offset+1).replaceAll("/",".");
		String part[]= classFQN.split("\\.");
		String className = part[part.length-2];
		
		
		ASTParser parser = ASTParser.newParser(AST.JLS3);
		
		String source = FileSystem.readFile(filePath);
		
		//System.out.println(source);
		
		parser.setSource(source.toCharArray());
		parser.setKind(ASTParser.K_COMPILATION_UNIT);
		final CompilationUnit cu = (CompilationUnit) parser.createAST(null);
	    
	    List<TypeDeclaration> classes =  cu.types();
	    
	    for(int i=0;i<classes.size();i++){
	    	TypeDeclaration curType = classes.get(i);
	    	//System.out.println(classes.get(i).getName());
	    	MethodDeclaration[] methodList = curType.getMethods();
	    	for(int j=0; j<methodList.length; j++){
	    		MethodDeclaration cMethod = methodList[j];
	    		//System.out.println("\t"+cMethod.getName());
	    		//ASTNode m = (ASTNode) cMethod;
	    		
	    		//CompilationUnit cu1 = (CompilationUnit) cMethod;
	    		//System.out.println(cMethod);
	    		//System.out.println(cu1.getCommentList());
	    		
	    		//debugging by Tung
	    		String key = "";
	    		key = (classFQN.substring(0, classFQN.length()-5)+"."+cMethod.getName()).trim();
	    		
	    		System.out.println(key);
	    		
	    		boolean isThisMethodIgnored = true;
	    		for (int k=0; k< coveredMethods.size(); k++) {
	    			if (key.endsWith(coveredMethods.get(k)) || coveredMethods.get(k).endsWith(key) || key.contains(coveredMethods.get(k)) || coveredMethods.get(k).contains(key)) {
	    				isThisMethodIgnored = false;
	    				coveredMethods.remove(k);
	    				//System.out.println(key);
	    				break;
	    			}
	    		}

	    		if (isThisMethodIgnored) {
	    			continue;
	    		} 
	    		
	    		// end injecting code by Tung
	    		
	    		ASTParser parserM = ASTParser.newParser(AST.JLS3);
	    		parserM.setSource(cMethod.toString().toCharArray());
	    		parserM.setKind(ASTParser.K_COMPILATION_UNIT);
	    		final CompilationUnit cu1 = (CompilationUnit) parserM.createAST(null);
	    		//CompilationUnit cu1 = PPAUtil.getCU(cMethod.toString(), new PPAOptions());
	    		
	    	    List<ASTNode> list = cu.getCommentList();
	    	    
	    	    
	    	    String fileName = "/method-"+count;
	    	    
	    		File file = new File(outputDir+fileName);

	    		// if file doesnt exists, then create it
	    		if (!file.exists()) {
	    			file.createNewFile();
	    		}

	    		FileWriter fw = new FileWriter(file.getAbsoluteFile());
	    		BufferedWriter bw = new BufferedWriter(fw);
	    	    
	    		
	    	    
	    	    
	    	    bw.write("<DOC>\n\t<DOCNO>"+key+" </DOCNO>\n\t<TEXT>");
	        	bw.newLine();
	        	bw.write("<class>");        
	        	bw.newLine();
	        	bw.write(className);
	        	bw.newLine();
	    	    
	        	bw.write(PreProcessor.transform(className));
	        	bw.newLine();
	        	bw.write("</class>");        
	        	bw.newLine();
	        	
	        	bw.write("<method>");  
	        	bw.newLine();
	        	bw.write(cMethod.getName().toString());
	        	bw.newLine();
	    	    
	        	bw.write(PreProcessor.transform(cMethod.getName().toString()));
	        	bw.newLine();
	        	bw.write("</method>");  
	        	bw.newLine();
	        	
	    	    //bw.write("code");
	    	    //bw.newLine();
	    	    GenericVisitor visitor = new GenericVisitor(bw);
	    	    bw.write("<identifier>");   
	        	bw.newLine();
	    	    try{
	    	    	bw.write(cMethod.getName().toString());
	    	    	bw.newLine();
	    	    	cMethod.accept(visitor);
	    	    }
	    	    catch(Exception e){
	    	    	e.printStackTrace();
	    	    }
	    	    bw.write("</identifier>");   
	        	bw.newLine();
	        	
	        	fDocument = new Document(cMethod.toString());
	    		
	    	    
	    		List <ASTNode> list1 = cu1.getCommentList();
	    		
	        	bw.write("<comments>");   
	        	bw.newLine();
	    	    for(int k=0;k<list1.size();k++){
	    	    	
	    	    	//System.out.println("COMMENT:\n\n");
	    	    	//System.out.println(list1.size());
	    	    	//System.out.println(list1);
	    	    	ASTNode cComment = list1.get(k);
	    	    	String comStr = getCommentString(cComment);
	    	    	bw.write(PreProcessor.process(comStr));
	    	    	bw.newLine();
	    	    }	
	        	bw.write("</comments>");   
	        	bw.newLine();
	        	bw.write("\t</TEXT>\n</DOC>");
	        	bw.newLine();
	    	    bw.close();
	    	    count++;
	    	}
	    	
	    }    
		}
	    System.out.println("End");
		
		System.out.print("Methods not found: ");
		System.out.print(coveredMethods.size());
		System.out.println(" out of " + filteredMethod.length);
		for (int i=0; i<coveredMethods.size(); i++){
			System.out.println(coveredMethods.get(i));
		}
	}
	
    private static String getCommentString(ASTNode node) {
        try {
            return fDocument.get(node.getStartPosition(), node.getLength());
        } catch (BadLocationException e) {
            e.printStackTrace();
        }
        return null;
    }
    

}

