package td.utils;

import java.util.Map;

public class Metrics {
	private String queryName = "";
	private double MRR = 0;
	private double MP;
	private int top1 = 0;
	private int top5 = 0;
	private int top10 = 0;
	
	public Metrics(){};
	
	public Metrics (String query, Map<String, Integer> sortedMap) {
		setQueryName(query);
		
		// calculate MRR
//		ArrayList<Integer> ranks = (ArrayList<Integer>) sortedMap.values();
//		setMRR(ranks.get(0));
		
		//calculate MP
		double sumMP = 0;
		int index = 1;
		for (int rank : sortedMap.values()) {
			if (index == 1) {
				setMRR((double) 1/rank);
			}
			
			sumMP += (double) index/rank;
			index += 1;
		}
		
		if (index > 1) {
			setMP((double) sumMP/(index-1));
		}
		
		//calculate tops
		for (int rank : sortedMap.values()) {
			if (rank == 1) {
				setTop1(getTop1() + 1);
				setTop5(getTop5() + 1);
				setTop10(getTop10() + 1);
			} else if ((1 < rank) && (rank <= 5)) {
				setTop5(getTop5() + 1);
				setTop10(getTop10() + 1);
			} else if ((5 < rank) && (rank <= 10)) {
				setTop10(getTop10() + 1);
			}
		}
	}
	
	public void print() {
		System.out.println(">>>Metrics for the query Name: " + queryName);
		System.out.println("MRR = " + MRR + ";" + "MP = " + MP);
		System.out.println("Top 1 = " + top1 + "; " + "Top 5 = " + top5 + ";" + "Top 10 = " + top10);
	}
	
	public String printToString() {
		String s = ">>>Metrics for the query Name: " + queryName + "\n";
		s += "MRR = " + MRR + ";" + "MP = " + MP + "\n";
		s += "Top 1 = " + top1 + "; " + "Top 5 = " + top5 + ";" + "Top 10 = " + top10 + "\n";
		return s;
	}

	public double getMRR() {
		return MRR;
	}

	public void setMRR(double mRR) {
		MRR = mRR;
	}

	public String getQueryName() {
		return queryName;
	}

	public void setQueryName(String queryName) {
		this.queryName = queryName;
	}

	public double getMP() {
		return MP;
	}

	public void setMP(double mP) {
		MP = mP;
	}

	public int getTop1() {
		return top1;
	}

	public void setTop1(int top1) {
		this.top1 = top1;
	}

	public int getTop5() {
		return top5;
	}

	public void setTop5(int top5) {
		this.top5 = top5;
	}

	public int getTop10() {
		return top10;
	}

	public void setTop10(int top10) {
		this.top10 = top10;
	}

}
