package td.utils;

public class SPFormula {
	
	public static double getMetric(String whichMetric, String ef, String ep, String nf, String np){
		switch (whichMetric) {
		case "T":
			return getTarantula(ef, ep, nf, np);
		case "O":
			return	getOchiai(ef, ep, nf, np);
		case "J":
			return getJaccard(ef, ep, nf, np);
		case "A":
			return getAmple(ef, ep, nf, np);
		}
		return -1;
	}
	
	public static double getTarantula(String ef, String ep, String nf, String np) {
		int failedExecutedTests = Integer.parseInt(ef);
		int failedNonExecutedTests = Integer.parseInt(nf);
		int passedExecutedTests = Integer.parseInt(ep);
		int passedNonExecutedTests = Integer.parseInt(np);
		int totalFailed = failedExecutedTests + failedNonExecutedTests;
		int totalPassed = passedExecutedTests + passedNonExecutedTests;
		
		double tarantula;
		
		if (totalFailed == 0) {
			tarantula = 0;
			return tarantula;
		} 
		
		if (totalPassed == 0) {
			tarantula = 1;
			return tarantula;
		}
		
		if (failedExecutedTests == 0) {
			tarantula = 0;
			return tarantula;
		}
		
		if (passedExecutedTests == 0) {
			tarantula = 1;
			return tarantula;
		}
		
		tarantula = (failedExecutedTests / (double)totalFailed)/((failedExecutedTests / (double)totalFailed)+(passedExecutedTests / (double)totalPassed));
		return tarantula;
	}
	
	public static double getOchiai(String ef, String ep, String nf, String np) {
		double failedExecutedTests = Double.parseDouble(ef);
		double failedNonExecutedTests = Double.parseDouble(nf);
		double passedExecutedTests = Double.parseDouble(ep);
		double passedNonExecutedTests = Double.parseDouble(np);
		double totalFailed = failedExecutedTests + failedNonExecutedTests;
		double totalPassed = passedExecutedTests + passedNonExecutedTests;
		
		double totalExecuted = failedExecutedTests + passedExecutedTests;
		
		double ochiai;
		
		if ((totalFailed == 0) || (totalExecuted == 0)) {
			ochiai = 0;
		} else {
			ochiai = failedExecutedTests / Math.sqrt(totalFailed*totalExecuted);
		}
		return ochiai;
	}
	
	public static double getJaccard(String ef, String ep, String nf, String np) {
		double failedExecutedTests = Double.parseDouble(ef);
		double failedNonExecutedTests = Double.parseDouble(nf);
		double passedExecutedTests = Double.parseDouble(ep);
		double passedNonExecutedTests = Double.parseDouble(np);
		double totalFailed = failedExecutedTests + failedNonExecutedTests;
		double totalPassed = passedExecutedTests + passedNonExecutedTests;
		
		double jaccard;
		
		if ((totalFailed + passedExecutedTests) == 0) {
			jaccard = 0;
		} else {
			jaccard = failedExecutedTests / (totalFailed + passedExecutedTests);
		}
		return jaccard;
	}
	
	public static double getAmple(String ef, String ep, String nf, String np) {
		double failedExecutedTests = Double.parseDouble(ef);
		double failedNonExecutedTests = Double.parseDouble(nf);
		double passedExecutedTests = Double.parseDouble(ep);
		double passedNonExecutedTests = Double.parseDouble(np);
		double totalFailed = failedExecutedTests + failedNonExecutedTests;
		double totalPassed = passedExecutedTests + passedNonExecutedTests;
		
		double ample;
		
		if ((totalFailed == 0) && (totalPassed == 0)) {
			ample = 0;
			return ample;
		}
		
		if ((totalFailed == 0) && (totalPassed != 0)) {
			ample = passedExecutedTests / totalPassed;
			return ample;
		}
		
		if ((totalFailed != 0) && (totalPassed == 0)) {
			ample = failedExecutedTests / totalFailed;
			return ample;
		}
		
		ample = Math.abs((failedExecutedTests / totalFailed - passedExecutedTests / totalPassed));
		return ample;
	}
	
	

	public static void main(String[] args) {
		// TODO Auto-generated method stub

	}

}
