#!/bin/sh

#
# This configurations are for LUCENE
#

###--------input data----------------------------
dataset="aspectj"
CODE_DIR="/Users/assist/tools/ibugs_aspectj-1.3/versions"

######## Java program setings####################
EXTRACTOR_PATH="/Users/assist/dataset/TCM/DLo/jars/java_structured_extractor.jar"


######## OUTPUT FOLDERS #########################
JAVA_STRUCTURED_DIR="/Users/assist/class-ir/$dataset/all/java"
INDEXES_DIR="/Users/assist/class-ir/$dataset/all/corpuses"



############ EMPTY OUTPUT FOLDERS ##############

if [ ! -d "$JAVA_STRUCTURED_DIR" ]
then
    mkdir "$JAVA_STRUCTURED_DIR"
else
    rm -rfv $JAVA_STRUCTURED_DIR/*
fi

if [ ! -d "$INDEXES_DIR" ]
then
    mkdir "$INDEXES_DIR"
else
    rm -rfv $INDEXES_DIR/*
fi

#################### START FROM HERE ################

BUGIDS=$(ls $CODE_DIR)

for i in $BUGIDS
do
    VERSIONS=$(ls $CODE_DIR/$i)

    if [ ! -d "$JAVA_STRUCTURED_DIR/$i" ]
    then	    
	mkdir "$JAVA_STRUCTURED_DIR/$i"
    fi

    if [ ! -d "$INDEXES_DIR/$i" ]
    then
	mkdir "$INDEXES_DIR/$i"
    fi

    for j in $VERSIONS
    do
	INPUT_PATH="$CODE_DIR/$i/$j"
	echo "Start processing $i --> $j ... [ok]"
	
	JVS_PATH="$JAVA_STRUCTURED_DIR/$i/$j"
	
	if [ ! -d "$JVS_PATH" ]
	then
	    mkdir "$JVS_PATH"
	fi
		
	INDEX_PATH="$INDEXES_DIR/$i/$j"
	if [ ! -d "$INDEX_PATH" ]
	then
	    mkdir "$INDEX_PATH"
	fi

	java -jar $EXTRACTOR_PATH $INPUT_PATH $JVS_PATH
	IndriBuildIndex -corpus.path=$JVS_PATH -corpus.class=trectext -index=$INDEX_PATH

	echo "Done processing $i --> $j ... [ok]"

    done    
done



