#!bash/sh
project="$1"
spectrum="$2" # either coverage or slicing

filter_dir="/Users/assist/dmz/filters/$spectrum/class/$project"
source_dir="/Users/assist/dmz/ir-dataset/code/$project"
dest_dir="/Users/assist/dmz/filter-code/$spectrum/$project"

if [ ! -d $dest_dir ]
then
    mkdir $dest_dir
else
    rm -rfv $dest_dir/*
fi

echo "Files not found: \n" > "/Users/assist/Desktop/files-not-found.txt"

bugs=$(ls "$filter_dir")

for b in $bugs
do
    
    echo "Working on  $b"
    
    dest="$dest_dir/$b"
    mkdir -p "$dest"
    
    source="$source_dir/$b/post-fix/lucene/src"
    cd "$source"

    files=$(cat "$filter_dir/$b")
    
    
    for f in $files
    do

	foundfiles=$(find . -name $f)

	for ff in $foundfiles
	do
	    if [ -e "$ff" ]
	    then
		rsync -avR "$ff" "$dest"
	    else
		echo "[error] $f does not exist"
		echo "$b:$ff" >> "/Users/assist/Desktop/files-not-found.txt"
	    fi	
	    
	done	
	
    done

    echo "-----------------------------"
done

cat "/Users/assist/Desktop/files-not-found.txt"

