#!/bin/sh

###--------input data----------------------------

dataset="$1" # project name
level="$2" # class or method level


### make sure all input arguments are correct ###

if [ $dataset == "ant53" ]
then
    echo "You are indexing : $dataset"
elif [ $dataset == "lucene37" ]
then
    echo "You are indexing project: $dataset"
elif [ $dataset == "rhino" ]
then
    echo "You are indexing project: $dataset"
elif [ $dataset == "aspectj" ]
then
    echo "You are indexing project: $dataset"
else
    echo "[error] You are entering incorrect argument. The program will exit..."
    exit -1
fi	     

if [ $level == "class" ]
then
    echo "Indexing at : $level level"
elif [ $level == "method" ]
then    
    echo "Indexing at: $level level"
else
    echo "[error] Incorrect argument! should be either class or method. The program will exit..."
    exit
fi

base="/Users/assist/dmz"
     
CODE_DIR="$base/ir-dataset/code/$dataset"

######## Extracting Jar Path ####################
EXTRACTOR_PATH="$base/lib/ir-jars/$level-extractor.jar"

######## OUTPUT FOLDERS #########################
gen_dir="$base/gen-data/ir"

if [ ! -d "$gen_dir" ]
then
    echo "[error] Data generated folder ($gen_dir) does not exist."
    exit -1
else
    if [ ! -d "$gen_dir/$level-ir" ]
    then	
	echo "[error] Folder ($gen_dir/$level-ir) does not exist."
    fi
fi
    

if [ ! -d "$gen_dir/$level-ir/$dataset/all/java" ]
then
    echo "Please make this folder first: $gen_dir/$level-ir/$dataset/all/java"
    exit
else
    rm -rfv $gen_dir/$level-ir/$dataset/all/java/*
fi    


JAVA_STRUCTURED_DIR="$gen_dir/$level-ir/$dataset/all/java"

#################### START FROM HERE ################

BUGIDS=$(ls $CODE_DIR)

for i in $BUGIDS
do
    mkdir "$JAVA_STRUCTURED_DIR/$i"
    
    VERSIONS=$(ls $CODE_DIR/$i)
    
    for j in $VERSIONS
    do
	echo "Start processing $i --> $j ... [ok]"
	
	INPUT_PATH="$CODE_DIR/$i/$j"
	
	JVS_PATH="$JAVA_STRUCTURED_DIR/$i/$j"
	mkdir "$JVS_PATH"
	
	java -jar $EXTRACTOR_PATH $INPUT_PATH $JVS_PATH
	
	echo "[Java code input folder] ... [$INPUT_PATH]"
	echo "[Textual output folder] ... [$JVS_PATH]"
	
	echo "Done processing $i/ $j ... [ok]"	
    done

done
