#!/bin/sh

###--------input data----------------------------

dataset="$1" # project name
level="$2" # class or method level

### make sure all input arguments are correct ###

if [ $dataset == "ant53" ]
then
    echo "You are indexing : $dataset"
elif [ $dataset == "lucene37" ]
then
    echo "You are indexing project: $dataset"
elif [ $dataset == "rhino" ]
then
    echo "You are indexing project: $dataset"
elif [ $dataset == "aspectj" ]
then
    echo "You are indexing project: $dataset"
else
    echo "[error] You are entering incorrect argument. The program will exit..."
    exit -1
fi	     

if [ $level == "class" ]
then
    echo "Indexing at : $level level"
elif [ $level == "method" ]
then    
    echo "Indexing at: $level level"
else
    echo "[error] Incorrect argument! should be either class or method. The program will exit..."
    exit
fi

base="/Users/assist/dmz"
     
#CODE_DIR="$base/ir-dataset/code/$dataset"
CODE_DIR="$base/filter-code/slicing/$dataset"
#CODE_DIR="$base/filter-code/coverage/$dataset"

######## Extracting Jar Path ####################
EXTRACTOR_PATH="$base/lib/ir-jars/$level-extractor.jar"

######## OUTPUT FOLDERS #########################
#gen_dir="$base/gen-data/ir"
#gen_dir="$base/gen-data/ir_and_slicing"

gen_dir="$base/gen-data"

#if [ ! -d "$gen_dir" ]
#then
 #   echo "[error] Data generated folder ($gen_dir) does not exist."
  #  exit -1
#else
 #   if [ ! -d "$gen_dir/$level-ir" ]
  #  then	
#	echo "[error] Folder ($gen_dir/$level-ir) does not exist."
 #   fi
#fi
    

#if [ ! -d "$gen_dir/$level-ir/$dataset" ]
#then
 #   mkdir "$gen_dir/$level-ir/$dataset"
  #  mkdir "$gen_dir/$level-ir/$dataset/all"
#else
 #   if [ ! -d "$gen_dir/$level-ir/$dataset/all" ]
  #  then
#	mkdir "$gen_dir/$level-ir/$dataset/all"
 #   else
#	rm -rfv "$gen_dir/$level-ir/$dataset/all/*"
 #   fi
#fi    


#JAVA_STRUCTURED_DIR="$gen_dir/$level-ir/$dataset/all/java"
#INDEXES_DIR="$gen_dir/$level-ir/$dataset/all/corpuses"

#JAVA_STRUCTURED_DIR="$gen_dir/$level-ir/$dataset/cv/union/java"
#INDEXES_DIR="$gen_dir/$level-ir/$dataset/cv/union/corpuses"


JAVA_STRUCTURED_DIR="$gen_dir/ir_and_slicing/tmpdata/$dataset/docs"
INDEXES_DIR="$gen_dir/ir_and_slicing/tmpdata/$dataset/index"

#JAVA_STRUCTURED_DIR="$gen_dir/$level-ir/lucene37_only/all/java"
#INDEXES_DIR="$gen_dir/$level-ir/lucene37_only/all/corpuses"


mkdir -p "$JAVA_STRUCTURED_DIR"
mkdir -p "$INDEXES_DIR"


#################### START FROM HERE ################

BUGIDS=$(ls $CODE_DIR)

for i in $BUGIDS
do
    mkdir "$JAVA_STRUCTURED_DIR/$i"
    mkdir "$INDEXES_DIR/$i"

#    VERSIONS=$(ls $CODE_DIR/$i)
    
 #   for j in $VERSIONS
  #  do
	echo "Start processing $i --> $j ... [ok]"

	INPUT_PATH="$CODE_DIR/$i"

	
	JVS_PATH="$JAVA_STRUCTURED_DIR/$i"
	mkdir "$JVS_PATH"
	
	INDEX_PATH="$INDEXES_DIR/$i"
	mkdir "$INDEX_PATH"
	
	java -jar $EXTRACTOR_PATH $INPUT_PATH $JVS_PATH
	IndriBuildIndex -corpus.path=$JVS_PATH -corpus.class=trectext -index=$INDEX_PATH
	
	echo "[input] ... [$INPUT_PATH]"
	echo "[output] ... [$JVS_PATH]"
	
#	echo "Done processing $i --> $j ... [ok]"
	
	# done

done
