#!/bin/sh

#
# This configurations are for LUCENE
#

###--------input data----------------------------
dataset="$1"
set_opt="$2"
level="$3"

if [ $dataset == "ant53" ]
then
    echo "Indexing ... ant53"
elif [ $dataset == "lucene37" ]
then
    echo "Indexing ... lucene37"
elif [ $dataset == "rhino" ]
then
    echo "Indexing ... rhino"
elif [ $dataset == "aspectj" ]
then
    echo "Indexting ... aspectj"
else
    echo "[error] Incorrect project name"
    exit
fi

if [ $set_opt == "union" ]
then
    echo "indexing with Uinion of tests traces"
elif [ $set_opt == "intersection" ]
then
    echo "Indexing with Intersection of tests traces"
else
    echo "[error] Incorect set operator"
    exit
fi

if [ $level == "method" ]
then
    echo "Indexing at Method level"
elif [ $level == "class" ]
then
    echo "Indexing at class level"
else
    echo "[error] Incorrect input level: only class or method"
    exit
fi
     

CODE_DIR="/Users/assist/dmz/ir-dataset/code/$dataset"
cv_data_dir="/Users/assist/dmz/gen-data/faulttracer/$dataset/post-fix/coverage-data/$set_opt/$level" # we want to index these bugs in this directory only

######## Java program setings####################
EXTRACTOR2_PATH="/Users/assist/dmz/lib/ir-jars/$level-extractor-cv.jar"


######## OUTPUT FOLDERS #########################
JAVA_STRUCTURED_DIR="/Users/assist/dmz/gen-data/ir/$level-ir/$dataset/cv/$set_opt/java"
INDEXES_DIR="/Users/assist/dmz/gen-data/ir/$level-ir/$dataset/cv/$set_opt/corpuses"



############ EMPTY OUTPUT FOLDERS ##############

if [ ! -d "$JAVA_STRUCTURED_DIR" ]
then
    mkdir "$JAVA_STRUCTURED_DIR"
else
    rm -rfv $JAVA_STRUCTURED_DIR/*
fi

if [ ! -d "$INDEXES_DIR" ]
then
    mkdir "$INDEXES_DIR"
else
    rm -rfv $INDEXES_DIR/*
fi

#################### START FROM HERE ################

BUGIDS=$(ls $cv_data_dir | cut -f1 -d ".")

for i in $BUGIDS
do

    #if [ $i != "RHINO-409702" ]
    #then
#	continue
 #   fi
    
    
    VERSIONS=$(ls "$CODE_DIR/$i")

    if [ ! -d "$JAVA_STRUCTURED_DIR/$i" ]
    then	    
	mkdir "$JAVA_STRUCTURED_DIR/$i"
    fi

    if [ ! -d "$INDEXES_DIR/$i" ]
    then
	mkdir "$INDEXES_DIR/$i"
    fi

    for j in $VERSIONS
    do
	INPUT_PATH="$CODE_DIR/$i/$j"
	echo "Start processing $i --> $j ... [ok]"
	# Extracting java-structurelized with filter and indexing the faulty and fixed versions
	
	CLASS_CV_FILE="$cv_data_dir/$i.mcv"

	JVS_W_FILTER_PATH="$JAVA_STRUCTURED_DIR/$i/$j"
	
	if [ ! -d "$JVS_W_FILTER_PATH" ]
	then
	    mkdir "$JVS_W_FILTER_PATH"
	fi
		
	INDEX_W_FILTER_PATH="$INDEXES_DIR/$i/$j"
	if [ ! -d "$INDEX_W_FILTER_PATH" ]
	then
	    mkdir "$INDEX_W_FILTER_PATH"
	fi

	java -jar $EXTRACTOR2_PATH $INPUT_PATH $JVS_W_FILTER_PATH $CLASS_CV_FILE
	IndriBuildIndex -corpus.path=$JVS_W_FILTER_PATH -corpus.class=trectext -index=$INDEX_W_FILTER_PATH

	echo "Done processing $i --> $j ... [ok]"

    done    
done



