project="$1" # work on ant first
version="post-fix" # either pre-fix or post-fix

traces_dir="/Volumes/osxrep/traces/$project/$version" # input traces dir
slices_dir="/Users/assist/dmz/gen-data/jslicer/slices/$project/$version" # output slices dir
jslicer="/Users/assist/dmz/tools/javaslicer" #javaslicer dir
failed_test_dir="/Users/assist/dmz/src/rtp/DMZ/failed_tests/$project" # tests and conditions to be sliced

if [ ! -d $slices_dir ]
then
    mkdir "$slices_dir"
else
#    rm -rfv $slices_dir/* # empty the output dir first
    echo "dont empty the dir at this moment"
fi


exclusive_traces=$(ls "/Users/assist/dmz/gen-data/jslicer/slices/lucene37/union" | xargs)

#echo "$exclusive_traces"


traces=$(ls $traces_dir | grep ".trace$") # get all the traces 

for t in $traces
do
    # get test to be sliced and its slicing conditions
    tname="${t%.*}"

    tmpvar=$(echo "$exclusive_traces" | grep "$tname")

    if [ $? == 0 ]
    then
	#echo " found"
	echo $tname
	continue
    fi

#    if [ $tname != "ANT-5270" ] # need to  be tested
 #   then	
#	continue
 #   fi

    echo "----------------------"
    echo "Working on $tname"


    lines=$(cat "$failed_test_dir/$tname.txt")

    slicepoints="null"
    
    for l in $lines
    do
	pre=$(echo "$l" | cut -f 1 -d ":") # full test class name

	classname="${pre##*.}" # class name short
	
	tmethod=$(echo "$l" | cut -f 2 -d ":") # test method name
	points=$(echo "$l" | cut -f 3 -d ":") # slicing points

	if [[ "$points" == *\* ]]
	then
	    #slicepoints="$slicepoints,$pre.$tmethod:*"
	    slicepoints="$pre.$tmethod:*"
	elif [ "$points" != "" ]
	then
	    spoints=$(echo "$points" | tr  "," "\n")
	    for point in $spoints
	    do
		#		slicepoints="$slicepoints,$pre.$tmethod:$point:*"
		slicepoints="$pre.$tmethod:$point:*"
	    done
	elif [ "$points" == "" ]
	then
	    slicepoints="$pre.$tmethod:*" # slice everything
	else
	    continue # slicepoints must be specified, or it will be ignored for the next line (test)
	fi

	slice_conditions="$slicepoints"


	#slice_conditions="${slicepoints:1:${#slicepoints}-1}"
	echo "slice points for $t : $slice_conditions"
	# end of code to get tests and their slicing condition to be sliced
	echo "----------------------"
	
	if [ $project == "rhino" ]
	then
	    java -Xms512M -Xmx8g -jar $jslicer/assembly/slicer.jar -p $traces_dir/$t $slice_conditions | awk '/.*/{if($0~/The dynamic slice for criterion/){print $0}else if($0~/Slice consists of/){print $0}else if($0~/Computation took/){print $0}else if($0~/org.mozilla/){print $1}}'| awk '!x[$0]++' > $slices_dir/$tname.$classname.$tmethod.slice # generating slices from coressponding traces and slicing conditions
	elif [ $project == "lucene37" ]
	then
	    java -Xms512M -Xmx8g -jar $jslicer/assembly/slicer.jar -p $traces_dir/$t $slice_conditions | awk '/.*/{if($0~/The dynamic slice for criterion/){print $0}else if($0~/Slice consists of/){print $0}else if($0~/Computation took/){print $0}else if($0~/org.apache.lucene/){print $1}}'| awk '!x[$0]++' > $slices_dir/$tname.$classname.$tmethod.slice # generating slices from coressponding traces and slicing conditions
	elif [ $project == "ant53" ]
	then
	    java -Xms512M -Xmx8g -jar $jslicer/assembly/slicer.jar -p $traces_dir/$t $slice_conditions | awk '/.*/{if($0~/The dynamic slice for criterion/){print $0}else if($0~/Slice consists of/){print $0}else if($0~/Computation took/){print $0}else if($0~/org.apache.tools/){print $1}}'| awk '!x[$0]++' > $slices_dir/$tname.$classname.$tmethod.slice # generating slices from coressponding traces and slicing conditions
	else
	    echo "[error] $project is not supported yet"
	    exit
	fi
	
    done    

done


exit
