project="ant" # which project data
pre_post="fixed" # which version: either faulty or fixed

traces_output="/Users/assist/ndataset/dlo/projects/traces/$project/$pre_post" # where to store generated traces
class_dir="/Users/assist/ndataset/dlo/projects/$project" # directory where test classes and code under test classes are stored
failed_tests="/Users/assist/dataset/TCM/DLo/amldata/failed_tests/$project" # "failed" tests to be traced and sliced
jvslicer_dir="/Users/assist/tools/javaslicer" # javaslicer folder

bugs=$(ls $class_dir) # list of bug IDs

for b in $bugs
do
    echo "processing $b"
    
    version=$(ls "$class_dir/$b" | grep "$pre_post") # processing on faulty or fixed version

    if [ ! $? == 0 ]
    then
	continue
    fi
    
    cd "$class_dir/$b/$version" # go to that version's folder where classes are found

    CODE_CLASS="$class_dir/$b/$version/build/classes"
    TEST_CLASS="$class_dir/$b/$version/build/testcases"
    LIB="$class_dir/$b/$version/build/lib/*.jar"
    CLASSPATH="/Users/assist/tools/junit/junit.jar:/Users/assist/tools/junit/hamcrest-core-1.3.jar:$CODE_CLASS:$TEST_CLASS:$LIB:/Library/Java/JavaVirtualMachines/jdk1.7.0_79.jdk/Contents/Home/jre/lib/tools.jar"

    file="$failed_tests/$b.txt" # file that contains test classes to be processed

    tests=$(cat "$file" | cut -f 1 -d ":" | sort | uniq | sed -e 's/\n/ /g' | xargs) # get only FQN test classes

    echo "$tests"

    echo "Wilord967!" | sudo -S java -Xms4g -Xmx8g -javaagent:$jvslicer_dir/assembly/tracer.jar=tracefile:$traces_output/$b.trace -cp "$CLASSPATH" org.junit.runner.JUnitCore $tests  > $traces_output/$b.log # javaslicer to generate traces for the coressponding test classes
    
    cat "$traces_output/$b.log" | grep "OK " # if all tests are passed
    
    if [ ! $? == 0 ]
    then
	mv $traces_output/$b.log $traces_output/$b.err.log
    fi

done

