#!/bin/sh

#
# This configurations are for LUCENE
#

###--------input data----------------------------
dataset="lucene"
CODE_DIR="/Users/assist/ndataset/dlo/projects/$dataset"
slicing_data_dir="/Users/assist/ndataset/dlo/projects/slicing-data/$dataset/method-slicing" # we want to index these bugs in this directory only

######## Java program setings####################
EXTRACTOR2_PATH="/Users/assist/dataset/TCM/DLo/jars/method_extractor_3.jar"


######## OUTPUT FOLDERS #########################
JAVA_STRUCTURED_DIR="/Users/assist/method-ir/$dataset/slicing/java"
INDEXES_DIR="/Users/assist/method-ir/$dataset/slicing/corpuses"



############ EMPTY OUTPUT FOLDERS ##############

if [ ! -d "$JAVA_STRUCTURED_DIR" ]
then
    mkdir "$JAVA_STRUCTURED_DIR"
else
    rm -rfv $JAVA_STRUCTURED_DIR/*
fi

if [ ! -d "$INDEXES_DIR" ]
then
    mkdir "$INDEXES_DIR"
else
    rm -rfv $INDEXES_DIR/*
fi


#################### START FROM HERE ################

BUGIDS=$(ls $slicing_data_dir | cut -f1 -d ".")

for i in $BUGIDS
do
    VERSIONS=$(ls $CODE_DIR/$i)

    if [ ! -d "$JAVA_STRUCTURED_DIR/$i" ]
    then	    
	mkdir "$JAVA_STRUCTURED_DIR/$i"
    fi

    if [ ! -d "$INDEXES_DIR/$i" ]
    then
	mkdir "$INDEXES_DIR/$i"
    fi

    for j in $VERSIONS
    do
	INPUT_PATH="$CODE_DIR/$i/$j/lucene/src"
	echo "Start processing $i --> $j ... [ok]"
	# Extracting java-structurelized with filter and indexing the faulty and fixed versions
	
	CLASS_SLICING_FILE="$slicing_data_dir/$i.txt"

	JVS_W_FILTER_PATH="$JAVA_STRUCTURED_DIR/$i/$j"
	
	if [ ! -d "$JVS_W_FILTER_PATH" ]
	then
	    mkdir "$JVS_W_FILTER_PATH"
	fi
		
	INDEX_W_FILTER_PATH="$INDEXES_DIR/$i/$j"
	if [ ! -d "$INDEX_W_FILTER_PATH" ]
	then
	    mkdir "$INDEX_W_FILTER_PATH"
	fi

	java -jar $EXTRACTOR2_PATH $INPUT_PATH $JVS_W_FILTER_PATH $CLASS_SLICING_FILE
	IndriBuildIndex -corpus.path=$JVS_W_FILTER_PATH -corpus.class=trectext -index=$INDEX_W_FILTER_PATH

	echo "Done processing $i --> $j ... [ok]"

    done    
done



