project="rhino" # which data project to work on
pre_post="post-fix" # which versions: either fixed or faulty

traces_dir="/Users/assist/ndataset/dlo/projects/slicer-data/traces/$project/$pre_post" # input traces dir
slices_dir="/Users/assist/ndataset/dlo/projects/slicer-data/slices/$project/$pre_post" # output slices dir
jslicer="/Users/assist/tools/javaslicer" #javaslicer dir
failed_test_dir="/Users/assist/dataset/TCM/DLo/amldata/failed_tests/$project" # tests and conditions to be sliced

if [ ! -d $slices_dir ]
then
    mkdir "$slices_dir"
else
    #rm -rfv $slices_dir/* # empty the output dir first
    echo "the dir is already existed and wont be deleted"
fi


traces=$(ls $traces_dir | grep ".trace$") # get all the traces 

for t in $traces
do
    # get test to be sliced and its slicing conditions
    tname="${t%.*}"

    if [ $tname != "510504" ]
    then
	continue
    fi
    

    lines=$(cat "$failed_test_dir/RHINO-$tname.txt")
    slicepoints=""
    for l in $lines
    do

#	l="$l:*" # slicing all --> remember to remove later
#	echo "$l"
#	exit
	
	pre=$(echo "$l" | cut -f 1 -d ":") # test class name
	tmethod=$(echo "$l" | cut -f 2 -d ":") # test method name
	points=$(echo "$l" | cut -f 3 -d ":") # slicing points

	if [[ "$points" == *\* ]]
	then
	    slicepoints="$slicepoints,$pre.$tmethod"
	else
	    spoints=$(echo "$points" | tr  "," "\n")
	    for point in $spoints
	    do
		slicepoints="$slicepoints,$pre.$tmethod:$point:*"
	    done
	fi
    done
    echo "----------------------"
    slice_conditions="${slicepoints:1:${#slicepoints}-1}"
    echo "slice points for $t : $slice_conditions"
    # end of code to get tests and their slicing condition to be sliced
    
    echo "Wilord967!" | sudo -S java -Xms512M -Xmx8g -jar $jslicer/assembly/slicer.jar -p $traces_dir/$t $slice_conditions | awk '/.*/{if($0~/The dynamic slice for criterion/){print $0}else if($0~/Slice consists of/){print $0}else if($0~/Computation took/){print $0}else if($0~/org.mozilla/){print $1}}'| awk '!x[$0]++' > $slices_dir/$tname.slice # generating slices from coressponding traces and slicing conditions


done
