#!bin/sh
xml_dir="/Users/assist/dataset/TCM/DLo/amldata/lucene_bugs_manager/fault-tracer"
failed_test_dir="/Users/assist/dataset/TCM/DLo/amldata/failed_tests/lucene"
lucene_dir="/Users/assist/ndataset/dlo/projects/dataset/lucene37"

faulttracer_dir="/Users/assist/tools/faulttracer_v2"
classes="lucene/build/classes/java"
test_classes="lucene/build/classes/test"
lib="lucene/lib"
pre_fix="org.apache.lucene"

bugs=$(ls $failed_test_dir)

for b in $bugs
do
    id=$(echo $b | cut -f 1 -d ".")
    test_names=$(cut -f 1 -d ":" $failed_test_dir/$id.txt | sort | uniq | xargs | sed 's/ /:/g')

    echo "<project name=\"FaultTracer-specific\">" > "$xml_dir/$id.faulttracer.xml"
    echo "<property name=\"subject\" value=\"$id\"/>" >> "$xml_dir/$id.faulttracer.xml"
    echo "<property name=\"prefix\" value=\"$pre_fix\"/>" >> "$xml_dir/$id.faulttracer.xml"
    echo "<property name=\"testsuite\" value=\"$test_names\"/>" >> "$xml_dir/$id.faulttracer.xml"
    echo "<property name=\"newversion\" value=\"\"/>" >> "$xml_dir/$id.faulttracer.xml"
    echo "<property name=\"junit4\" value=\"true\"/>" >> "$xml_dir/$id.faulttracer.xml"
    echo "<property name=\"faulttracer\" value=\"$faulttracer_dir\"/>" >> "$xml_dir/$id.faulttracer.xml"
    echo "<property name=\"cp\" value=\"./$classes;./$test_classes;./$lib/*;\"/>" >> "$xml_dir/$id.faulttracer.xml"
    echo "<property name=\"faulttracer.maxmemory\" value=\"1048m\"/>" >> "$xml_dir/$id.faulttracer.xml"
    echo "<import file=\"\${faulttracer}/resources/faulttracer.xml\"/>" >> "$xml_dir/$id.faulttracer.xml"
    echo "</project>"  >> "$xml_dir/$id.faulttracer.xml"

    cp "$xml_dir/$id.faulttracer.xml" "$lucene_dir/$id/post-fix/$id.faulttracer.xml"
    cp "$xml_dir/$id.faulttracer.xml" "$lucene_dir/$id/pre-fix/$id.faulttracer.xml"
done
