#!/bin/sh

###--------input data----------------------------
dataset="lucene"
QUERIES_DIR="/Users/assist/ndataset/dlo/projects/ir-queries/$dataset"
CORPUS_DIR="/Users/assist/method-ir/$dataset/all/corpuses"


######## OUTPUT FOLDERS #########################
RESULTS_DIR="/Users/assist/method-ir/$dataset/all/results"

if [ ! -d "$RESULTS_DIR" ]
then
    mkdir "$RESULTS_DIR"
    mkdir "$RESULTS_DIR/fixed"
    mkdir "$RESULTS_DIR/faulty"
else
    rm -rfv $RESULTS_DIR/*
    mkdir "$RESULTS_DIR/fixed"
    mkdir "$RESULTS_DIR/faulty"
fi

QUERIES=$(ls $CORPUS_DIR)

for q in $QUERIES
do
    echo "Start working on $q ... [ok]"
    
    QUERY_FILE="$QUERIES_DIR/$q"
    VERSIONS=$(ls $CORPUS_DIR/$q)

    for i in $VERSIONS
    do
	echo "$i" | grep "fixed"

	if [ $? == 0 ]
	then		
	    indrirunquery $QUERY_FILE -index=$CORPUS_DIR/$q/$i -trecFormat=true -count=50000 > "$RESULTS_DIR/fixed/$q"
	else
	    indrirunquery $QUERY_FILE -index=$CORPUS_DIR/$q/$i -trecFormat=true -count=50000 > "$RESULTS_DIR/faulty/$q"
	fi	    
    done

    echo "$q .... [done]"

done

