#!/bin/sh

###--------input data----------------------------
dataset="$1"
QUERIES_DIR="/Users/assist/ndataset/dlo/projects/ir-queries/$dataset"
CORPUS_DIR="/Users/assist/class-ir/$dataset/cv/corpuses"


######## OUTPUT FOLDERS #########################
RESULTS_DIR="/Users/assist/class-ir/$dataset/cv/results"

if [ ! -d "$RESULTS_DIR" ]
then
    mkdir "$RESULTS_DIR"
    mkdir "$RESULTS_DIR/post-fix"
    mkdir "$RESULTS_DIR/pre-fix"
else
    rm -rfv $RESULTS_DIR/*
    mkdir "$RESULTS_DIR/post-fix"
    mkdir "$RESULTS_DIR/pre-fix"
fi

QUERIES=$(ls $CORPUS_DIR)

for q in $QUERIES
do
    echo "Start working on $q ... [ok]"

    if [ "$dataset" == "rhino" ]
    then
	QUERY_FILE="$QUERIES_DIR/RHINO-$q"
    else
	QUERY_FILE="$QUERIES_DIR/$q"
    fi
    
    VERSIONS=$(ls $CORPUS_DIR/$q)

    for i in $VERSIONS
    do
	echo "$i" | grep "post-fix"

	echo "$QUERY_FILE"
	echo "$CORPUS_DIR/$q/$i"
	
	if [ $? == 0 ]
	then		
	    indrirunquery $QUERY_FILE -index=$CORPUS_DIR/$q/$i -trecFormat=true -count=50000 > "$RESULTS_DIR/post-fix/$q"
	else
	    indrirunquery $QUERY_FILE -index=$CORPUS_DIR/$q/$i -trecFormat=true -count=50000 > "$RESULTS_DIR/pre-fix/$q"
	fi	    
    done

    echo "$q .... [done]"

done

